diff --git a/network.c b/network.c
new file mode 100644
index 0000000..8392ff6
--- /dev/null
+++ b/network.c
@@ -0,0 +1,305 @@
+/*
+ * most of this code is base on or copied from the
+ * "UNIX Network Programming" Book by W.Richard Stevens, Bill Fenner
+ * and Andrew M. Rudoff (ISBN: 0-13-141155-1)
+ */
+
+#include "debug.h"
+#include "network.h"
+
+/*
+ * tcp_connect()
+ *   connect to host:serv
+ */
+int
+tcp_connect(const char *host, const char *serv)
+{ /*{{{*/
+	int    sockfd, n;
+	struct addrinfo hints, *res, *ressave;
+
+	memset(&hints, 0, sizeof(struct addrinfo));
+	hints.ai_family = AF_UNSPEC;
+	hints.ai_socktype = SOCK_STREAM;
+
+	if ( (n = getaddrinfo(host, serv, &hints, &res)) != 0) {
+		errno_msg("tcp_connect() error for %s, %s: %s",
+			  host, serv, gai_strerror(n));
+		return(-1);
+	}
+	ressave = res;
+
+	do {
+		sockfd = socket(res->ai_family, res->ai_socktype, res->ai_protocol);
+		if (sockfd < 0)
+			continue; /* ignore this one */
+
+		if (connect(sockfd, res->ai_addr, res->ai_addrlen) == 0)
+			break;    /* success */
+
+		xclose(sockfd);  /* ignore this one */
+	} while ( (res = res->ai_next) != NULL);
+
+	if (res == NULL)  /* errno set from final connect() */
+		errno_msg("tcp_connect() error for %s, %s", host, serv);
+
+	freeaddrinfo(ressave);
+
+	return(sockfd);
+} /*}}}*/
+
+/*
+ * sock_ntop()
+ *   protocol (IPv4 vs. IPv6) independent version of inet_ntop
+ */
+char *
+sock_ntop(const struct sockaddr *sa, socklen_t salen)
+{ /*{{{*/
+	char   portstr[8];
+	static char str[128];   /* Unix domain is largest */
+	struct sockaddr_in  *sin  = (struct sockaddr_in  *) sa;
+#ifdef AF_INET6
+	struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *) sa;
+#endif
+
+	switch (sa->sa_family) {
+	case AF_INET:
+		if (inet_ntop(AF_INET, &sin->sin_addr, str, sizeof(str)) == NULL)
+			return(NULL);
+		if (ntohs(sin->sin_port) != 0) {
+			snprintf(portstr, sizeof(portstr), ":%d", ntohs(sin->sin_port));
+			strcat(str, portstr);
+		}
+		return(str);
+
+#ifdef AF_INET6
+	case AF_INET6:
+		str[0] = '[';
+		if (inet_ntop(AF_INET6, &sin6->sin6_addr, str + 1, sizeof(str) - 1) == NULL)
+			return(NULL);
+		if (ntohs(sin6->sin6_port) != 0) {
+			snprintf(portstr, sizeof(portstr), "]:%d", ntohs(sin6->sin6_port));
+			strcat(str, portstr);
+			return(str);
+		}
+		return (str + 1);
+#endif
+
+	default:
+		snprintf(str, sizeof(str), "sock_ntop: unknown AF_xxx: %d, len %d",
+			 sa->sa_family, salen);
+		return(str);
+	}
+	return (NULL);
+} /*}}}*/
+
+/* wrapper for sock_ntop(), that handles error codes */
+char *
+xsock_ntop(const struct sockaddr *sa, socklen_t salen)
+{ /*{{{*/
+	char *ptr;
+
+	if ( (ptr = sock_ntop(sa, salen)) == NULL)
+		errno_msg("sock_ntop() error");
+	return(ptr);
+} /*}}}*/
+
+/*
+ * sock_ntop_host()
+ *   similar to sock_ntop(), but only returns the host portion (not the port)
+ */
+char *
+sock_ntop_host(const struct sockaddr *sa, socklen_t salen)
+{ /*{{{*/
+	static char str[128];   /* Unix domain is largest */
+	struct sockaddr_in  *sin = (struct sockaddr_in *) sa;
+#ifdef AF_INET6
+	struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *) sa;
+#endif
+
+	switch (sa->sa_family) {
+	case AF_INET:
+		if (inet_ntop(AF_INET, &sin->sin_addr, str, sizeof(str)) == NULL)
+			return(NULL);
+		return(str);
+
+#ifdef AF_INET6
+	case AF_INET6:
+		if (inet_ntop(AF_INET6, &sin6->sin6_addr, str, sizeof(str)) == NULL)
+			return(NULL);
+		return(str);
+#endif
+
+	default:
+		snprintf(str, sizeof(str), "sock_ntop_host: unknown AF_xxx: %d, len %d",
+		sa->sa_family, salen);
+		return(str);
+	}
+	return (NULL);
+} /*}}}*/
+
+/* wrapper for sock_ntop_host(), that handles error codes */
+char *
+xsock_ntop_host(const struct sockaddr *sa, socklen_t salen)
+{ /*{{{*/
+	char  *ptr;
+
+	if ( (ptr = sock_ntop_host(sa, salen)) == NULL)
+		errno_msg("sock_ntop_host() error");  /* inet_ntop() sets errno */
+	return(ptr);
+} /*}}}*/
+
+/*
+ * sock_get_port()
+ *   protocol independent way to get the port of a socket
+ */
+int
+sock_get_port(const struct sockaddr *sa, socklen_t salen)
+{ /*{{{*/
+	struct sockaddr_in  *sin  = (struct sockaddr_in  *) sa;
+#ifdef AF_INET6
+	struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *) sa;
+#endif
+
+	switch (sa->sa_family) {
+	case AF_INET:
+		return(sin->sin_port);
+
+#ifdef AF_INET6
+	case AF_INET6:
+		return(sin6->sin6_port);
+#endif
+	}
+	return(-1);
+} /*}}}*/
+
+/*
+ * sock_set_addr()
+ *   protocol independent way to set the address of a socket
+ */
+void
+sock_set_addr(struct sockaddr *sa, socklen_t salen, const void *addr)
+{ /*{{{*/
+	struct sockaddr_in  *sin  = (struct sockaddr_in  *) sa;
+#ifdef AF_INET6
+	struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *) sa;
+#endif
+
+	switch (sa->sa_family) {
+	case AF_INET:
+		memcpy(&sin->sin_addr, addr, sizeof(struct in_addr));
+	return;
+
+#ifdef AF_INET6
+	case AF_INET6:
+		memcpy(&sin6->sin6_addr, addr, sizeof(struct in6_addr));
+	return;
+#endif
+	}
+} /*}}}*/
+
+/*
+ * sock_set_addr()
+ *   protocol independent way to set the port of a socket
+ */
+void
+sock_set_port(struct sockaddr *sa, socklen_t salen, int port)
+{ /*{{{*/
+	struct sockaddr_in  *sin  = (struct sockaddr_in  *) sa;
+#ifdef AF_INET6
+	struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *) sa;
+#endif
+
+	switch (sa->sa_family) {
+	case AF_INET:
+		sin->sin_port = port;
+		return;
+
+#ifdef AF_INET6
+	case AF_INET6:
+		sin6->sin6_port = port;
+		return;
+#endif
+	}
+	return;
+} /*}}}*/
+
+/*
+ * readn()
+ *   read 'n' bytes from a filedescriptor
+ */
+ssize_t
+readn(int fd, void *vptr, size_t n)
+{ /*{{{*/
+	size_t  nleft;
+	ssize_t nread;
+	char  *ptr;
+
+	ptr = vptr;
+	nleft = n;
+	while (nleft > 0) {
+		if ( (nread = read(fd, ptr, nleft)) < 0) {
+			if (errno == EINTR)
+				nread = 0;    /* and call read() again */
+			else
+				return(-1);
+		}
+		else if (nread == 0) {
+			break; /* EOF */
+		}
+
+		nleft -= nread;
+		ptr   += nread;
+	}
+	return(n - nleft);    /* return >= 0 */
+} /*}}}*/
+
+ssize_t
+xreadn(int fd, void *ptr, size_t nbytes)
+{ /*{{{*/
+	ssize_t   n;
+
+	if ( (n = readn(fd, ptr, nbytes)) < 0)
+		errno_msg("readn() error");
+	return(n);
+} /*}}}*/
+
+/*
+ * writen
+ *   write 'n' bytes to a descriptor
+ */
+ssize_t
+writen(int fd, const void *vptr, size_t n)
+{ /*{{{*/
+	size_t    nleft;
+	ssize_t   nwritten;
+	const char  *ptr;
+
+	ptr = vptr;
+	nleft = n;
+	while (nleft > 0) {
+		if ( (nwritten = write(fd, ptr, nleft)) <= 0) {
+			if (nwritten < 0 && errno == EINTR)
+				nwritten = 0;   /* and call write() again */
+			else
+				return(-1);     /* error */
+		}
+
+		nleft -= nwritten;
+		ptr   += nwritten;
+	}
+	return(n);
+} /*}}}*/
+
+void
+xwriten(int fd, void *ptr, size_t nbytes)
+{ /*{{{*/
+	if (writen(fd, ptr, nbytes) != nbytes)
+		errno_msg("writen() error");
+} /*}}}*/
+
+void
+xclose(int fd)
+{ /*{{{*/
+	if (close(fd) == -1)
+		errno_msg("close() error");
+} /*}}}*/
diff --git a/network.h b/network.h
new file mode 100644
index 0000000..1b9cd65
--- /dev/null
+++ b/network.h
@@ -0,0 +1,37 @@
+#ifndef x__NETWORK_H
+#define x__NETWORK_H
+
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netdb.h>
+#include <arpa/inet.h>
+#include <stdio.h>
+#include <string.h>
+#include <stdarg.h>
+#include <unistd.h>
+#include <errno.h>
+
+#include "compiler.h"
+
+#define MAX_ERR_LINE 512
+
+int      tcp_connect(const char *host, const char *serv);
+char    *sock_ntop(const struct sockaddr *sa, socklen_t salen);
+char    *sock_ntop_host(const struct sockaddr *sa, socklen_t salen);
+int      sock_get_port(const struct sockaddr *sa, socklen_t salen);
+void     sock_set_addr(struct sockaddr *sa, socklen_t salen, const void *ptr);
+void     sock_set_port(struct sockaddr *sa, socklen_t salen, int port);
+ssize_t  readn(int fd, void *vptr, size_t n);
+ssize_t  writen(int fd, const void *vptr, size_t n);
+
+/* wrapper functions */
+char    *xsock_ntop(const struct sockaddr *sa, socklen_t salen);
+char    *xsock_ntop_host(const struct sockaddr *sa, socklen_t salen);
+ssize_t  xreadn(int fd, void *ptr, size_t nbytes);
+void     xwriten(int fd, void *ptr, size_t nbytes);
+void     xclose(int fd);
+
+/* helper functions */
+void errno_msg(const char *fmt, ...) __FORMAT(1, 2);
+
+#endif /* x__NETWORK_H */
diff --git a/options.c b/options.c
index 8628e82..fc1990c 100644
--- a/options.c
+++ b/options.c
@@ -21,6 +21,7 @@
 #include "file.h"
 #include "prog.h"
 #include "output.h"
+#include "as.h"
 #include "config/datadir.h"
 
 #include <stdio.h>
@@ -186,6 +187,7 @@ static const char * const valid_sort_keys[] = {
 	"date",
 	"genre",
 	"filename",
+	"albumartist",
 	NULL
 };
 
@@ -255,6 +257,30 @@ static void set_lib_sort(unsigned int id, const char *buf)
 		editable_set_sort_keys(&lib_editable, keys);
 }
 
+static void get_as_pass(unsigned int id, char *buf)
+{
+	strncpy(buf, as_authinfo.pass, OPTION_MAX_SIZE-1);
+	buf[OPTION_MAX_SIZE-1]='\0';
+}
+
+static void set_as_pass(unsigned int id, const char *buf)
+{
+	strncpy(as_authinfo.pass, buf, OPTION_MAX_SIZE-1);
+	as_authinfo.pass[OPTION_MAX_SIZE-1]='\0';
+}
+
+static void get_as_user(unsigned int id, char *buf)
+{
+	strncpy(buf, as_authinfo.user, OPTION_MAX_SIZE-1);
+	buf[OPTION_MAX_SIZE-1]='\0';
+}
+
+static void set_as_user(unsigned int id, const char *buf)
+{
+	strncpy(as_authinfo.user, buf, OPTION_MAX_SIZE-1);
+	as_authinfo.pass[OPTION_MAX_SIZE-1]='\0';
+}
+
 static void get_pl_sort(unsigned int id, char *buf)
 {
 	strcpy(buf, pl_editable.sort_str);
@@ -377,6 +403,31 @@ static void toggle_auto_reshuffle(unsigned int id)
 	auto_reshuffle ^= 1;
 }
 
+static void get_as_enable(unsigned int id, char *buf)
+{
+	strcpy(buf, bool_names[as_enable]);
+}
+
+static void set_as_enable(unsigned int id, const char *buf)
+{
+	int old=as_enable;
+	if (parse_bool(buf, &as_enable) && !old) {
+		/* switch from off to on */
+		as_init();
+		return;
+	}
+	if (!as_enable && old) {
+		/* switch from on to off */
+		as_exit();
+	}
+}
+
+static void toggle_as_enable(unsigned int id)
+{
+	if (as_enable) set_as_enable(id, "false");
+	else           set_as_enable(id, "true");
+}
+
 static void get_continue(unsigned int id, char *buf)
 {
 	strcpy(buf, bool_names[player_cont]);
@@ -694,6 +745,9 @@ static const struct {
 	opt_toggle_cb toggle;
 } simple_options[] = {
 	DT(aaa_mode)
+	DT(as_enable)
+	DN(as_pass)
+	DN(as_user)
 	DT(auto_reshuffle)
 	DN(buffer_seconds)
 	DT(confirm_run)
@@ -756,9 +810,10 @@ static const struct {
 	{ "format_playlist",	" %-20a %02n. %t%= %y %d " },
 	{ "format_title",	"%a - %l - %t (%y)" },
 	{ "format_trackwin",	" %02n. %t%= %y %d " },
-
 	{ "lib_sort"	,	"artist album discnumber tracknumber title filename" },
 	{ "pl_sort",		"" },
+	{ "as_pass",		"" },
+	{ "as_user",		"" },
 	{ "id3_default_charset","ISO-8859-1" },
 	{ NULL, NULL }
 };
diff --git a/pl.c b/pl.c
index da460cf..dea4079 100644
--- a/pl.c
+++ b/pl.c
@@ -6,6 +6,7 @@
 #include "editable.h"
 #include "options.h"
 #include "xmalloc.h"
+#include "as.h"
 
 struct editable pl_editable;
 struct simple_track *pl_cur_track = NULL;
@@ -86,6 +87,7 @@ struct track_info *pl_set_selected(void)
 	if (list_empty(&pl_editable.head))
 		return NULL;
 
+	as_hook(AS_PL_ENTER);
 	window_get_sel(pl_editable.win, &sel);
 	return set_track(iter_to_simple_track(&sel));
 }
diff --git a/player.c b/player.c
index a68f89d..55fd732 100644
--- a/player.c
+++ b/player.c
@@ -26,6 +26,7 @@
 #include "xmalloc.h"
 #include "debug.h"
 #include "compiler.h"
+#include "as.h"
 
 #include <stdlib.h>
 #include <pthread.h>
@@ -207,6 +208,7 @@ static inline unsigned int buffer_second_size(void)
 
 static inline int get_next(char **filename)
 {
+	as_hook(AS_AUTONEXT);
 	return player_cbs->get_next(filename);
 }
 
diff --git a/spawn.c b/spawn.c
index 68b5ed3..77f519a 100644
--- a/spawn.c
+++ b/spawn.c
@@ -41,7 +41,7 @@ int spawn(char *argv[], int *status)
 		return -1;
 	} else if (pid == 0) {
 		/* child */
-		int dev_null, err;
+		int dev_null, err, i;
 
 		close(err_pipe[0]);
 		fcntl(err_pipe[1], F_SETFD, FD_CLOEXEC);
@@ -56,6 +56,10 @@ int spawn(char *argv[], int *status)
 		/* not interactive, close stdin */
 		close(0);
 
+		/* close unused fds */
+		for (i = 3; i < 30; i++)
+			close(i);
+
 		execvp(argv[0], argv);
 
 		/* error */
diff --git a/strlib.c b/strlib.c
new file mode 100644
index 0000000..cb183d1
--- /dev/null
+++ b/strlib.c
@@ -0,0 +1,357 @@
+/*
+ * strlib.[ch] - a string handling library
+ *  See strlib.h for notes about libowfat (the code this is based on).
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+ * 02111-1307, USA.
+ */
+
+#include <stdlib.h>
+#include <string.h>
+
+#include "debug.h"
+#include "strlib.h"
+
+/*
+ * {con,de}structor
+ */
+void str_init(string_t *st)
+{ /*{{{*/
+	st->s=0;
+	st->len=st->all=0;
+} /*}}}*/
+
+void str_free(string_t *st)
+{ /*{{{*/
+	if (st->s && st->all > 0) free(st->s);
+	st->s=0;
+	st->len=st->all=0;
+} /*}}}*/
+
+/*
+ * allocation functions
+ */
+int str_ready(string_t *st, unsigned long int len)
+{ /*{{{*/
+	/*
+	 * makes sure st can take up at least len bytes.
+	 * this code allocates a few more bytes tthan needed,
+	 * so that small additions can be made without realloc()s
+	 * return 1 on success 0 otherwise (as in: realloc() fails)
+	 */
+	int c=len+(len>>3)+30;
+	char *tmp;
+	if (!st->s || st->all<len) {
+		/* mem needed */
+		if (!(tmp = realloc(st->s, c))) return 0;
+		st->all=c;
+		st->s=tmp;
+	}
+	return 1;
+} /*}}}*/
+
+int str_readya(string_t *st, unsigned long int len)
+{ /*{{{*/
+	/*
+	 * adds at least len bytes to the current length of *st
+	 */
+	if (st->s) {
+		if (st->len + len < len) return 0;
+		return str_ready(st, st->len + len);
+	}
+	else
+		return str_ready(st, len);
+} /*}}}*/
+
+/*
+ * string copy functions
+ */
+int str_ncpy(string_t *st, const char *buf, unsigned long int len)
+{ /*{{{*/
+	/*
+	 * copy len bytes from *buf into *st
+	 * return 1 on success, 0 otherwise.
+	 */
+	unsigned long int i;
+	if (buf == NULL || len == 0) {
+		st->len=0;
+		if (st->all != 0)
+			st->s[0] = '\0';
+		return(1);
+	}
+	if (!str_ready(st, len)) return(0);
+	/*
+	 * FIXME: these copying loops should be put into a sep. function
+	 *        to keep the code maintainable.
+	 */
+	for (i=0; i <= len - 1; i++) {
+		st->s[i] = buf[i];
+	}
+	st->s[len] = '\0';
+	st->len=len;
+	return(1);
+} /*}}}*/
+
+int str_cpy(string_t *st0, string_t *st1)
+{ /*{{{*/
+	/*
+	 * copy *st1's string into *st0
+	 */
+	return(str_ncpy(st0, st1->s, st1->len));
+} /*}}}*/
+
+/*
+ * concatenation functions
+ */
+int str_ncat(string_t *st, const char *buf, unsigned long int len)
+{ /*{{{*/
+	/*
+	 * add *buf to *st
+	 */
+	unsigned long int i;
+	if (len == 0 || buf == NULL) {
+		return(1);
+	}
+	if (!str_readya(st, len+1)) return(0);
+	for (i=st->len; i <= st->len + len - 1; i++) {
+		st->s[i] = buf[i - st->len];
+	}
+	st->len+=len;
+	st->s[st->len]='\0';
+	return(1);
+} /*}}}*/
+
+int str_cat(string_t *st0, string_t *st1)
+{ /*{{{*/
+	/*
+	 * add *st1 to *st0 (*st1 must be allocated already);
+	 */
+	return(str_ncat(st0, st1->s, st1->len));
+} /*}}}*/
+
+/*
+ * comparison functions
+ */
+int str_compstart(string_t *st, const char *buf)
+{ /*{{{*/
+	/* 
+	 * check if *st starts with *buf.
+	 * return 1 if that's the case, 0 otherwise
+	 */
+	unsigned long int i;
+	unsigned long int len=strlen(buf) - 1;
+	if (st->len <= len) return(0);
+	for (i=0; i<=len; i++)
+		if (st->s[i]!=buf[i]) return(0);
+	return(1);
+} /*}}}*/
+
+int str_scomp(string_t *st, const char *buf)
+{ /*{{{*/
+	/*
+	 * lexically compare *st with the *buf character array.
+	 * return -1, 1, or 0
+	 */
+	unsigned long int i, j;
+	for (i=0;;++i) {
+		if (i==st->len)
+			return( !buf[i] ? 0 : -1 );
+		if (!buf[i])
+			return 1;
+		j = (unsigned char)(st->s[i]) - (unsigned char)(buf[i]);
+		if (j)
+			return( j>0 ? 1 : -1 );
+	}
+	return(0);                                                                                                                                
+} /*}}}*/
+
+int str_comp(string_t *st0, string_t *st1)
+{ /*{{{*/
+	/*
+	 * lexically compare *st0 with *st1
+	 * return -1, 1 or 0
+	 */
+	return(str_scomp(st0, st1->s));
+} /*}}}*/
+
+/*
+ * replacement functions
+ */
+int str_nreplace(string_t *st, unsigned long int idx, unsigned long int offset, const char *replacement, unsigned long int rlen)
+{ /*{{{*/
+	/*
+	 * replace offset bytes from idx in *st with len bytes from
+	 * replacement; return 1 on success, 0 on memory problems, negative
+	 * values upon logical errors in parameters.
+	 */
+	char *rest;
+	int restlen;
+
+	if (idx > st->len)
+		return(-2);
+	if (idx+offset > st->len)
+		return(-3);
+
+	restlen = st->len - idx - offset;
+	if (!(rest = malloc(restlen * sizeof(char) + 1)))
+		return(0);
+
+	strncpy(rest, st->s+idx+offset, restlen); /* st->s+st->len is '\0' */
+	rest[restlen] = '\0';
+	if (rlen > offset) {
+		/* we might need to allocate more memory */
+		if (!str_readya(st, rlen-offset)) {
+			free(rest);
+			return(0);
+		}
+	}
+	st->s[idx] = '\0';
+	st->len = idx;
+	str_ncat(st, replacement, rlen);
+	str_ncat(st, rest, restlen);
+	free(rest);
+	return(1);
+} /*}}}*/
+
+int str_replace(string_t *st, unsigned long int idx, unsigned long int offset, string_t *replacement)
+{ /*{{{*/
+	return(str_nreplace(st, idx, offset, replacement->s, replacement->len));
+} /*}}}*/
+
+/*
+ * search functions
+ */
+int
+str_ngetidx(string_t *haystack, unsigned long int offset, const char *needle, unsigned long int nlen, unsigned long int *idx)
+{ /*{{{*/
+	unsigned long int i, j;
+	if (nlen == 0 || haystack->len == 0 || haystack->len < offset || nlen > haystack->len-offset)
+		return(0);
+
+	for (i=0; i<= haystack->len-offset-1; ++i) {
+		if (haystack->s[offset+i] == needle[0]) {
+			/* potential hit */
+			if (nlen == 1) {
+				if (idx != NULL)
+					*idx=i+offset;
+				return(1);
+			}
+			for (j=1; j<=nlen-1; ++j) {
+				if (haystack->s[offset+i+j] != needle[j])
+					break;
+				if (haystack->s[offset+i+j] == needle[j] && j == nlen-1) {
+					if (idx != NULL)
+						*idx=i+offset;
+					return(1);
+				}
+			}
+		}
+	}
+	return (0);
+} /*}}}*/
+
+int
+str_getidx(string_t *haystack, unsigned long int offset, string_t *needle, unsigned long int *idx)
+{ /*{{{*/
+	return(str_ngetidx(haystack, offset, needle->s, needle->len, idx));
+} /*}}}*/
+
+/*
+ * conversion functions
+ */
+int
+str_nlat1_to_utf8(string_t *converted, const unsigned char *input, unsigned long len)
+{ /*{{{*/
+	unsigned long int nc=0, olen=0, ilen;
+	unsigned char *in;
+
+	in = (unsigned char *)input;
+	ilen = 0;
+	while (ilen++ <= len)
+		if (*(in++) > 0x7f)
+			++nc;
+
+	if (nc) {
+		if (!str_readya(converted, nc))
+			return(0);
+	}
+	else
+		return(1);
+
+	in = (unsigned char *)input;
+	ilen = 0;
+	while (ilen++ <= len) {
+		if (*in > 0x7f) {
+			converted->s[olen++] = 0xC0 | (*in >> 6);
+			*in = (0x80 | (*in & 0x3F));
+		}
+		converted->s[olen++] = *in;
+		in++;
+	}
+	converted->s[olen] = '\0';
+	converted->len = olen;
+	return(1);
+} /*}}}*/
+
+int
+str_lat1_to_utf8(string_t *converted, string_t *input)
+{ /*{{{*/
+	return(str_nlat1_to_utf8(converted, input->s, input->len));
+} /*}}}*/
+
+/*
+ * Perl lookalikes
+ */
+int str_chop(string_t *st)
+{ /*{{{*/
+	/*
+	 * remove last character of *st
+	 * return removed byte or -1 if *st if empty
+	 */
+	int r;
+	if (!st->len)
+		return(-1);
+	r=st->s[st->len-1];
+	st->s[st->len--]=0;
+	return(r);
+} /*}}}*/                                                                                                                                           
+                                                                                                                                            
+int str_chomp(string_t *st)
+{ /*{{{*/
+	/*
+	 * remove "\r" "\n" "\r\n" from *st's end.
+	 * return count of rem. chars (poss. values: 0,1,2);
+	 */
+	if (!st->len)
+		return(0);
+	if (st->len==1) {
+		if (st->s[st->len-1] == '\r' || st->s[st->len-1] == '\n') {
+			st->s[0]=0; st->len=0;
+			return(1);
+		}
+		else
+			return(0);
+	}
+	if (st->s[st->len-1] == '\r' || st->s[st->len-1] == '\n') {
+		if (st->s[st->len-1] == '\n' && st->s[st->len-2]) {
+			st->s[st->len-2]=0;
+			st->len-=2;
+			return(2);
+		}
+		st->s[--st->len]=0;
+		return(1);
+	}
+	return(0);
+} /*}}}*/
diff --git a/strlib.h b/strlib.h
new file mode 100644
index 0000000..31c0194
--- /dev/null
+++ b/strlib.h
@@ -0,0 +1,88 @@
+/*
+ * strlib.[ch] - a string handling library
+ *  Some time ago, I've been writing a few functions to handle strings,
+ *  mainly as an exercise. When someone hinted me at fefe's libowfat[1],
+ *  I found that the basic idea was quite similar, but libowfat was
+ *  doing a lot of things quite smart, so I rewrote my functions while
+ *  looking at the libowfat sources. So, this code is heavily based
+ *  on these sources.
+ *
+ * Note, that libowfat is not only about strings, it does lots of
+ * things, you might find useful. Take a look at it!
+ *
+ * [1] http://www.fefe.de/libowfat/
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+ * 02111-1307, USA.
+ */
+
+#ifndef x__STRLIB_H
+#define x__STRLIB_H
+
+/* internal structure */
+typedef struct {
+	/*
+	 *  s:    string
+	 *  len:  length of string
+	 *  all:  allocated bytes for *s
+	 */
+	char *s;
+	unsigned long int len;
+	unsigned long int all;
+} string_t;
+
+/* {con,de}structor */
+void  str_init(string_t *st);
+void  str_free(string_t *st);
+
+/* allocation functions */
+int   str_ready(string_t *st, unsigned long int len);
+int   str_readya(string_t *st, unsigned long int len);
+
+/* string copy functions */
+int   str_ncpy(string_t *st, const char *buf, unsigned long int len);
+#define str_scpy(st, buf) str_ncpy(st, buf, ( buf == NULL ? 0 : strlen(buf) ))
+int   str_cpy(string_t *st0, string_t *st1);
+
+/* concatenation functions */
+int   str_ncat(string_t *st, const char *buf, unsigned long int len);
+#define str_scat(st, buf) str_ncat(st, buf, ( buf == NULL ? 0 : strlen(buf) ))
+int   str_cat(string_t *st0, string_t *st1);
+
+/* comparison functions */
+int   str_compstart(string_t *st, const char *buf);
+int   str_scomp(string_t *st, const char *buf);
+int   str_comp(string_t *st0, string_t *st1);
+
+/* replacement functions */
+int str_nreplace(string_t *st, unsigned long int idx, unsigned long int offset, const char *replacement, unsigned long int rlen);
+#define str_sreplace(st, idx, offset, repl) str_nreplace(st, idx, offset, repl, strlen(repl))
+int str_replace(string_t *st, unsigned long int idx, unsigned long int offset, string_t *replacement);
+
+/* search functions */
+int str_ngetidx(string_t *haystack, unsigned long int offset, const char *needle, unsigned long int nlen, unsigned long int *idx);
+#define str_sgetidx(hs, offset, n, idx) str_ngetidx(hs, offset, n, strlen(n), idx)
+int str_getidx(string_t *haystack, unsigned long int offset, string_t *needle, unsigned long int *idx);
+
+/* conversion functions */
+int str_nlat1_to_utf8(string_t *converted, const unsigned char *input, unsigned long len);
+#define str_slat1_to_utf8(c, s) str_nlat1_to_utf8(c, s, strlen(s))
+int str_lat1_to_utf8(string_t *converted, string_t *input);
+
+/* Perl lookalikes */
+int   str_chop(string_t *st);
+int   str_chomp(string_t *st);
+
+#endif /* x__STRLIB_H */
diff --git a/tabexp.c b/tabexp.c
index c7a5a18..271da5f 100644
--- a/tabexp.c
+++ b/tabexp.c
@@ -1,22 +1,3 @@
-/* 
- * Copyright 2004-2005 Timo Hirvonen
- * 
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation; either version 2 of the
- * License, or (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
- * 02111-1307, USA.
- */
-
 #include "tabexp.h"
 #include "xmalloc.h"
 #include "xstrjoin.h"
@@ -26,51 +7,36 @@
 
 struct tabexp tabexp = {
 	.head = NULL,
-	.tails = NULL,
-	.nr_tails = 0,
+	.tails = NULL
 };
 
-/* index to tabexp.tails */
-static int tabexp_index = 0;
-
 char *tabexp_expand(const char *src, void (*load_matches)(const char *src))
 {
-	if (tabexp.tails == NULL) {
-		char *expanded;
+	static int idx = 0;
+	char *expanded;
 
+	if (tabexp.tails == NULL) {
 		load_matches(src);
-
 		if (tabexp.tails == NULL) {
 			BUG_ON(tabexp.head != NULL);
-			BUG_ON(tabexp.nr_tails != 0);
 			return NULL;
 		}
-
 		BUG_ON(tabexp.head == NULL);
-		BUG_ON(tabexp.nr_tails < 1);
-
-		expanded = xstrjoin(tabexp.head, tabexp.tails[0]);
-		if (tabexp.nr_tails == 1)
-			tabexp_reset();
-		return expanded;
-	} else {
-		tabexp_index++;
-		tabexp_index %= tabexp.nr_tails;
-		return xstrjoin(tabexp.head, tabexp.tails[tabexp_index]);
+		idx = 0;
 	}
+
+	expanded = xstrjoin(tabexp.head, tabexp.tails[idx++]);
+	if (!tabexp.tails[idx])
+		idx = 0;
+	if (!tabexp.tails[1])
+		tabexp_reset();
+	return expanded;
 }
 
 void tabexp_reset(void)
 {
-	int i;
-
-	for (i = 0; i < tabexp.nr_tails; i++)
-		free(tabexp.tails[i]);
-	free(tabexp.tails);
+	free_str_array(tabexp.tails);
 	free(tabexp.head);
 	tabexp.tails = NULL;
 	tabexp.head = NULL;
-	tabexp.nr_tails = 0;
-
-	tabexp_index = 0;
 }
diff --git a/tabexp.h b/tabexp.h
index 022e87c..d28d17c 100644
--- a/tabexp.h
+++ b/tabexp.h
@@ -23,7 +23,6 @@
 struct tabexp {
 	char *head;
 	char **tails;
-	int nr_tails;
 };
 
 extern struct tabexp tabexp;
diff --git a/tabexp_file.c b/tabexp_file.c
index 4dd08df..db64fd8 100644
--- a/tabexp_file.c
+++ b/tabexp_file.c
@@ -128,7 +128,6 @@ static void tabexp_load_dir(const char *dirname, const char *start,
 
 		tabexp.head = xstrdup(dirname);
 		tabexp.tails = array.ptrs;
-		tabexp.nr_tails = array.count;
 	}
 out:
 	free(full_dir_name);
@@ -157,7 +156,6 @@ void expand_files_and_dirs(const char *src,
 
 			if (home) {
 				tabexp.head = xstrdup("");
-				tabexp.nr_tails = 1;
 				tabexp.tails = xnew(char *, 2);
 				tabexp.tails[0] = home;
 				tabexp.tails[1] = NULL;
diff --git a/track.c b/track.c
index c8c9ef8..92271bf 100644
--- a/track.c
+++ b/track.c
@@ -14,24 +14,10 @@
 
 #include <string.h>
 
-static int xstrcasecmp(const char *a, const char *b)
-{
-	if (a == NULL) {
-		if (b == NULL)
-			return 0;
-		return -1;
-	} else if (b == NULL) {
-		return 1;
-	}
-	return u_strcasecmp(a, b);
-}
-
 void simple_track_init(struct simple_track *track, struct track_info *ti)
 {
 	track->info = ti;
 	track->marked = 0;
-	track->disc = comments_get_int(ti->comments, "discnumber");
-	track->num = comments_get_int(ti->comments, "tracknumber");
 }
 
 struct simple_track *simple_track_new(struct track_info *ti)
@@ -164,48 +150,6 @@ again:
 	return NULL;
 }
 
-int simple_track_cmp(const struct list_head *a_head, const struct list_head *b_head, const char * const *keys)
-{
-	const struct simple_track *a = to_simple_track(a_head);
-	const struct simple_track *b = to_simple_track(b_head);
-	int i, res = 0;
-
-	for (i = 0; keys[i]; i++) {
-		const char *key = keys[i];
-		const char *av, *bv;
-		const struct track_info *ai, *bi;
-
-		/* numeric compare for tracknumber and discnumber */
-		if (strcmp(key, "tracknumber") == 0) {
-			res = a->num - b->num;
-			if (res)
-				break;
-			continue;
-		}
-		if (strcmp(key, "discnumber") == 0) {
-			res = a->disc - b->disc;
-			if (res)
-				break;
-			continue;
-		}
-		ai = a->info;
-		bi = b->info;
-		if (strcmp(key, "filename") == 0) {
-			/* NOTE: filenames are not necessarily UTF-8 */
-			res = strcasecmp(ai->filename, bi->filename);
-			if (res)
-				break;
-			continue;
-		}
-		av = comments_get_val(ai->comments, key);
-		bv = comments_get_val(bi->comments, key);
-		res = xstrcasecmp(av, bv);
-		if (res)
-			break;
-	}
-	return res;
-}
-
 void sorted_list_add_track(struct list_head *head, struct simple_track *track, const char * const *keys)
 {
 	struct list_head *item;
@@ -215,7 +159,10 @@ void sorted_list_add_track(struct list_head *head, struct simple_track *track, c
 	 */
 	item = head->prev;
 	while (item != head) {
-		if (simple_track_cmp(&track->node, item, keys) >= 0)
+		const struct simple_track *a = to_simple_track(&track->node);
+		const struct simple_track *b = to_simple_track(item);
+
+		if (track_info_cmp(a->info, b->info, keys) >= 0)
 			break;
 		item = item->prev;
 	}
diff --git a/track.h b/track.h
index 271b5ae..df25e37 100644
--- a/track.h
+++ b/track.h
@@ -11,14 +11,7 @@
 struct simple_track {
 	struct list_head node;
 	struct track_info *info;
-
 	unsigned int marked : 1;
-
-	/* -1.. */
-	int disc : 15;
-
-	/* -1.. */
-	int num : 16;
 };
 
 struct shuffle_track {
@@ -71,7 +64,6 @@ struct simple_track *simple_list_get_next(struct list_head *head, struct simple_
 struct simple_track *simple_list_get_prev(struct list_head *head, struct simple_track *cur,
 		int (*filter)(const struct simple_track *));
 
-int simple_track_cmp(const struct list_head *a_head, const struct list_head *b_head, const char * const *keys);
 void sorted_list_add_track(struct list_head *head, struct simple_track *track, const char * const *keys);
 
 void shuffle_list_add_track(struct list_head *head, struct list_head *node, int nr);
